//
// JAN98.CPP
//
// When built with Borland C++ 5.0 or 5.2 from
// C++ Builder, this simple program generates a memory
// fault after a few more than 300 iterations through
// the loop.  Oddly enough, the length of the string
// that breaks, x, is in the 46,000 range, which wouldn't
// seem to be a magic number where memory problems occur.
//
// Compile this program like this:
//
//  BCC32 -tWM Jan98.cpp
//
// The program is well behaved when compiled with the
// single threaded library.  Using the multithreaded
// library by specifying -tWM is what breaks the
// program.
//

#include <iostream>
#include <string>

using namespace std;

main()
{
    string s;
    string x;
    for ( int i= 0 ; i < 1000 ; i++ ) {
        cout << i << " " << flush;
        s += '+';
        cout << s.size() << " " << flush;
        x += s;
        cout << x.size() << "\n" << flush;
    }
}
//EOF

